/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#define SEGMENT 2
double ***Count_Matrix = NULL;
int   param_val_array[SEGMENT] = { 0, 1 };
void  Calculate_Score (int comp, Ind * temp, int allele_group[4],
                       int *trt_data, int locus, int nfou);
void  Peeling_routine_lambdap (int comp_no, Ind * First_Element,
                               int *trt_data, int locus, int nfou);
int  *flagTablelambdap = NULL;
int  *Relation_Array_lambdap = NULL;
int  *Tag_lambdap = NULL;
int **FlagLambda_lambdap = NULL;

void initialize_flagTablelambdap ()
{
   int   i;
   flagTablelambdap = (int *) calloc (pedsize, sizeof (int));
   alloc_chk (WHERE, flagTablelambdap);
   for (i = 0; i < pedsize; i++)
   {
      flagTablelambdap[i] = 0;
   }
}

/* subroutine for computing the gene-graph for founder alleles */
void Relation_lambdap (int i, int nfou, int original, int *cnt)
{
   int   j = 0;
   Relation_Array_lambdap[i] = 1;

   while (j < (2 * nfou))
   {
      if ((Relation_Array_lambdap[j] != 1) && (j != original)
          && ((Count_Matrix[i][j][0] > 0) || (Count_Matrix[i][j][1] > 0)
              || (Count_Matrix[j][i][0] > 0) || (Count_Matrix[j][i][1] > 0))
          && (FlagLambda_lambdap[i][j] == 0))
      {
         FlagLambda_lambdap[i][j] = -1;
         FlagLambda_lambdap[j][i] = -1;
         Relation_Array_lambdap[j] = 1;
         *cnt = *cnt + 1;
         Tag_lambdap[j] = *cnt;
         Relation_lambdap (j, nfou, original, cnt);
      }
      j = j + 1;
   }
}

/* likelihood computation under (lambda,p) model */
double Calculate_Likelihood (int c, int nfou, int *trt_data, int locus,
                             double p, double lambda_aff, double lambda_unaff,
                             int Index)
{
   int   i, j, k, v, Config, v1;
   double likelihood, likelihood2, allocation_prb = 0;
   double likelihood1 = 0;
   double logfinalLikelihood = 1;
   int   sum = 0;
   int  *CntArray = NULL;
   int  *TotalParam = NULL;
   int   No_Aff_risk = 0;
   int   No_Unaff_risk = 0;
   int   No_Aff_nonrisk = 0;
   int   No_Unaff_nonrisk = 0;
   Ind  *First_Element = NULL;
   double Term1 = 0, NewTerm1 = 0, NewNewTerm1 = 1;
   double Term2 = 0, NewTerm2 = 0, NewNewTerm2 = 1;
   double Term3 = 0, NewTerm3 = 0, NewNewTerm3 = 1;

   initialize_flagTablelambdap ();
   Relation_Array_lambdap = (int *) calloc (2 * nfou, sizeof (int));
   alloc_chk (WHERE, Relation_Array_lambdap);

   Tag_lambdap = (int *) calloc (2 * nfou, sizeof (int));
   alloc_chk (WHERE, Tag_lambdap);

   Count_Matrix = (double ***) calloc (2 * nfou, sizeof (double **));
   alloc_chk (WHERE, Count_Matrix);

   for (i = 0; i < (2 * nfou); i++)
   {
      Count_Matrix[i] = (double **) calloc (2 * nfou, sizeof (double *));
      alloc_chk (WHERE, Count_Matrix[i]);

      for (j = 0; j < (2 * nfou); j++)
      {
         Count_Matrix[i][j] = (double *) calloc (2, sizeof (double));
         alloc_chk (WHERE, Count_Matrix[i][j]);
      }
   }
   FlagLambda_lambdap = (int **) calloc (2 * nfou, sizeof (int *));
   alloc_chk (WHERE, FlagLambda_lambdap);
   CntArray = (int *) calloc (2 * nfou, sizeof (int));
   alloc_chk (WHERE, CntArray);

   for (i = 0; i < (2 * nfou); i++)
   {
      FlagLambda_lambdap[i] = (int *) calloc (2 * nfou, sizeof (int));
      alloc_chk (WHERE, FlagLambda_lambdap[i]);
   }
   for (i = 0; i < pedsize; i++)
   {
      if (nghd[i].component == (c + 1))
      {
         First_Element = &nghd[i];
         Peeling_routine_lambdap (c, First_Element, trt_data, locus, nfou);
      }
   }

   sum = 0;
   for (i = 0; i < (2 * nfou); i++)
   {
      CntArray[i] = 0;
      if (Relation_Array_lambdap[i] == 0)
      {
         Relation_lambdap (i, nfou, i, &CntArray[i]);
         sum = sum + CntArray[i] + 1;
      }
      if (CntArray[i] > 0)
      {
         int   total_comb = (int) pow (SEGMENT, CntArray[i] + 1);

         TotalParam = NULL;

         TotalParam = (int *) calloc (total_comb, sizeof (int));
         alloc_chk (WHERE, TotalParam);

         likelihood2 = 0;
         Config = 0;
         NewTerm1 = 0;
         NewTerm2 = 0;
         while (Config < pow (SEGMENT, CntArray[i] + 1))
         {
            for (j = 0; j < (CntArray[i] + 1); j++)
            {
               int   gallop = (int) pow (SEGMENT, j);
               int   index = (int) Config / gallop;
               index = index % SEGMENT;
               TotalParam[CntArray[i] + 1 - j - 1] = param_val_array[index];
            }

            likelihood1 = 1;
            Term1 = 0;
            Term2 = 0;
            No_Aff_risk = 0;
            No_Aff_nonrisk = 0;
            No_Unaff_risk = 0;
            No_Unaff_nonrisk = 0;
            v = 0;
            allocation_prb = 1;

            for (v = 0; v < (CntArray[i] + 1); v++)
            {
               allocation_prb = allocation_prb * pow (p, 1 - TotalParam[v])
                  * pow ((1 - p), TotalParam[v]);
            }

            v = 0;
            for (k = (i + 1); k < (2 * nfou); k++)
            {
               if ((Tag_lambdap[k] > 0))
               {
                  if (((Count_Matrix[i][k][0] > 0)
                       || (Count_Matrix[i][k][1] > 0))
                      || ((Count_Matrix[k][i][0] > 0)
                          || (Count_Matrix[k][i][1] > 0)))
                  {
                     v = Tag_lambdap[k];

                     if ((TotalParam[v] == 1) && (TotalParam[0] == 1))
                     {
                        likelihood =
                           pow (.5, Count_Matrix[i][k][0]
                                + Count_Matrix[i][k][1]
                                + Count_Matrix[k][i][0]
                                + Count_Matrix[k][i][1]);
                     }
                     else if ((TotalParam[v] == 0) && (TotalParam[0] == 0))
                     {
                        likelihood =
                           pow (.5, Count_Matrix[i][k][0]
                                + Count_Matrix[i][k][1]
                                + Count_Matrix[k][i][0]
                                + Count_Matrix[k][i][1]);
                     }
                     else if ((TotalParam[v] == 0) && (TotalParam[0] == 1))
                     {
                        likelihood =
                           pow (1 - lambda_aff, Count_Matrix[i][k][0])
                           * pow (1 - lambda_unaff, Count_Matrix[i][k][1])
                           * pow (lambda_aff, Count_Matrix[k][i][0])
                           * pow (lambda_unaff, Count_Matrix[k][i][1]);
                        No_Aff_nonrisk = No_Aff_nonrisk + Count_Matrix[i][k][0];
                        No_Aff_risk = No_Aff_risk + Count_Matrix[k][i][0];
                        No_Unaff_nonrisk =
                           No_Unaff_nonrisk + Count_Matrix[i][k][1];
                        No_Unaff_risk = No_Unaff_risk + Count_Matrix[k][i][1];
                     }
                     else if ((TotalParam[v] == 1) && (TotalParam[0] == 0))
                     {
                        likelihood =
                           pow (lambda_aff, Count_Matrix[i][k][0])
                           * pow (lambda_unaff, Count_Matrix[i][k][1])
                           * pow (1 - lambda_aff, Count_Matrix[k][i][0])
                           * pow (1 - lambda_unaff, Count_Matrix[k][i][1]);
                        No_Aff_nonrisk = No_Aff_nonrisk + Count_Matrix[i][k][0];
                        No_Aff_risk = No_Aff_risk + Count_Matrix[k][i][0];
                        No_Unaff_nonrisk =
                           No_Unaff_nonrisk + Count_Matrix[i][k][1];
                        No_Unaff_risk = No_Unaff_risk + Count_Matrix[k][i][1];
                     }
                     likelihood1 = likelihood1 * likelihood;
                  }
               }
            }
            for (k = (i + 1); k < (2 * nfou - 1); k++)
            {
               for (j = (k + 1); j < (2 * nfou); j++)
               {
                  if ((Tag_lambdap[j] > 0) && (Tag_lambdap[k] > 0))
                  {
                     if (((Count_Matrix[j][k][0] > 0)
                          || (Count_Matrix[j][k][1] > 0))
                         || ((Count_Matrix[k][j][0] > 0)
                             || (Count_Matrix[k][j][1] > 0)))
                     {
                        v = Tag_lambdap[k];
                        v1 = Tag_lambdap[j];
                        likelihood = 0;

                        if ((TotalParam[v] == 1) && (TotalParam[v1] == 1))
                        {
                           likelihood =
                              pow (.5, (Count_Matrix[j][k][0] +
                                        Count_Matrix[j][k][1] +
                                        Count_Matrix[k][j][0] +
                                        Count_Matrix[k][j][1]));
                        }
                        else if ((TotalParam[v] == 0) && (TotalParam[v1] == 0))
                        {
                           likelihood =
                              pow (.5, (Count_Matrix[j][k][0] +
                                        Count_Matrix[j][k][1] +
                                        Count_Matrix[k][j][0] +
                                        Count_Matrix[k][j][1]));
                        }
                        else if ((TotalParam[v] == 0) && (TotalParam[v1] == 1))
                        {
                           likelihood =
                              pow (1 - lambda_aff, Count_Matrix[j][k][0])
                              * pow (1 - lambda_unaff, Count_Matrix[j][k][1])
                              * pow (lambda_aff, Count_Matrix[k][j][0])
                              * pow (lambda_unaff, Count_Matrix[k][j][1]);
                           No_Aff_nonrisk =
                              No_Aff_nonrisk + Count_Matrix[j][k][0];
                           No_Aff_risk = No_Aff_risk + Count_Matrix[k][j][0];
                           No_Unaff_nonrisk =
                              No_Unaff_nonrisk + Count_Matrix[j][k][1];
                           No_Unaff_risk =
                              No_Unaff_risk + Count_Matrix[k][j][1];
                        }
                        else if ((TotalParam[v] == 1) && (TotalParam[v1] == 0))
                        {
                           likelihood =
                              pow (lambda_aff, Count_Matrix[j][k][0])
                              * pow (lambda_unaff, Count_Matrix[j][k][1])
                              * pow (1 - lambda_aff, Count_Matrix[k][j][0])
                              * pow (1 - lambda_unaff, Count_Matrix[k][j][1]);
                           No_Aff_nonrisk =
                              No_Aff_nonrisk + Count_Matrix[j][k][0];
                           No_Aff_risk = No_Aff_risk + Count_Matrix[k][j][0];
                           No_Unaff_nonrisk =
                              No_Unaff_nonrisk + Count_Matrix[j][k][1];
                           No_Unaff_risk =
                              No_Unaff_risk + Count_Matrix[k][j][1];
                        }
                        likelihood1 = likelihood1 * likelihood;
                     }
                  }
               }
            }

            if ((No_Aff_risk > 0) && (No_Aff_nonrisk > 0))
            {
               Term1 = 2 * (No_Aff_risk - No_Aff_nonrisk);
            }
            else
            {
               Term1 = 2 * (No_Aff_risk + No_Aff_nonrisk);
            }
            if ((No_Unaff_risk > 0) && (No_Unaff_nonrisk > 0))
            {
               Term2 = 2 * (No_Unaff_risk - No_Unaff_nonrisk);
            }
            else
            {
               Term2 = 2 * (No_Unaff_risk + No_Unaff_nonrisk);
            }
            /* printf("%lf %lf= Terms %d\n",Term1,Term2,Config); */
            likelihood1 = allocation_prb * likelihood1;

            likelihood2 = likelihood2 + likelihood1;
            Term1 = allocation_prb * Term1;
            Term2 = allocation_prb * Term2;
            Term3 = allocation_prb * Term3;
            NewTerm1 = NewTerm1 + Term1;
            NewTerm2 = NewTerm2 + Term2;
            NewTerm3 = NewTerm3 + Term1 * Term2;
            /* printf("%lf %lf= NewTerms\n",NewTerm1,NewTerm2); */

            Config = Config + 1;
         }
         logfinalLikelihood = logfinalLikelihood * (likelihood2);
         NewNewTerm1 = NewNewTerm2 * NewTerm1;
         NewNewTerm2 = NewNewTerm2 * NewTerm2;
         NewNewTerm3 = NewNewTerm3 * NewTerm3;
      }
      /* printf("%lf %lf= NewNewTerms\n",NewNewTerm1,NewNewTerm2); */
      if (TotalParam)
      {
         free (TotalParam);
         TotalParam = NULL;
      }
      for (j = 0; j < 2 * nfou; j++)
      {
         Tag_lambdap[j] = 0;
      }
   }
   /* printf("End: Calculate_Likelihood val(%lf) at (%d)\n",
      logfinalLikelihood,__LINE__); */
   if (FlagLambda_lambdap)
   {
      for (i = 0; i < (2 * nfou); i++)
      {
         if (FlagLambda_lambdap[i])
         {
            free (FlagLambda_lambdap[i]);
            FlagLambda_lambdap[i] = NULL;
         }
      }
      free (FlagLambda_lambdap);
   }
   if (flagTablelambdap)
   {
      free (flagTablelambdap);
      flagTablelambdap = NULL;
   }
   if (Count_Matrix)
   {
      for (i = 0; i < (2 * nfou); i++)
      {
         if (Count_Matrix[i])
         {
            for (j = 0; j < (2 * nfou); j++)
            {
               if (Count_Matrix[i][j])
               {
                  free (Count_Matrix[i][j]);
                  Count_Matrix[i][j] = NULL;
               }
            }
            free (Count_Matrix[i]);
            Count_Matrix[i] = NULL;
         }
      }
      free (Count_Matrix);
      Count_Matrix = NULL;
   }
   if (CntArray)
      free (CntArray);
   CntArray = NULL;

   if (Tag_lambdap)
   {
      free (Tag_lambdap);
      Tag_lambdap = NULL;
   }
   if (Relation_Array_lambdap)
   {
      free (Relation_Array_lambdap);
      Relation_Array_lambdap = NULL;
   }

   Covariance[locus][Index] =
      Covariance[locus][Index] + pow ((double) 10, (double) 20) * NewNewTerm3;
   Variance1[locus][Index] =
      Variance1[locus][Index] + NewNewTerm1 * pow ((double) 10, (double) 20)
      * NewNewTerm1;
   Variance2[locus][Index] =
      Variance2[locus][Index] + pow ((double) 10, (double) 20)
      * NewNewTerm2 * NewNewTerm2;
   return ((logfinalLikelihood) * pow ((double) 10, (double) 20));
}

/* subroutine to peel the gene graph */
void Peeling_routine_lambdap (int comp_no, Ind * First_Element, int *trt_data,
                              int locus, int nfou)
{
   Ind  *spousePtr;
   Indlist *kidsPtr = NULL;
   Mar  *marCurrentPtr = NULL;
   Marlist *marListPtr = NULL;
   int   allele_group[4];
   if (First_Element == &nullnode)
   {
      return;
   }
   else if (flagTablelambdap[First_Element->index] == 1)
   {
      return;
   }
   else
   {
      marListPtr = First_Element->marriages;
      if (marListPtr == NULL)
      {
         flagTablelambdap[First_Element->index] = 1;
         return;
      }
      else
      {
         marCurrentPtr = marListPtr->current;
         if (marCurrentPtr != NULL)
         {
            spousePtr = marCurrentPtr->spouse;
            kidsPtr = marCurrentPtr->kids;
         }
      }
      if (First_Element->sex == 1)
      {
         allele_group[0] = gg0[locus][First_Element->index];
         allele_group[1] = gg1[locus][First_Element->index];
         allele_group[2] = gg0[locus][spousePtr->index];
         allele_group[3] = gg1[locus][spousePtr->index];
      }
      else if (First_Element->sex == 2)
      {
         allele_group[2] = gg0[locus][First_Element->index];
         allele_group[3] = gg1[locus][First_Element->index];
         allele_group[0] = gg0[locus][spousePtr->index];
         allele_group[1] = gg1[locus][spousePtr->index];
      }
      while (kidsPtr != NULL)
      {
         Calculate_Score (comp_no, kidsPtr->current, allele_group, trt_data,
                          locus, nfou);
         kidsPtr = kidsPtr->next;
      }

      flagTablelambdap[First_Element->index] = 1;
      flagTablelambdap[spousePtr->index] = 1;
      return;
   }
}

/* generating a matrix specifying the relatedness among individuals */
void Calculate_Score (int c, Ind * temp, int allele_group[4], int *trt_data,
                      int locus, int nfou)
{
   int   allele1, allele2;
   allele1 = gg0[locus][temp->index];
   allele2 = gg1[locus][temp->index];
   if (allele2 == allele_group[0])
   {
      if (trt_data[temp->index] == 2)
      {
         Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][0] + 1;
      }
      else if (trt_data[temp->index] == 1)
      {
         Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][1] + 1;
      }
      else if (trt_data[temp->index] == 0)
      {
         Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][1] + .5;
         Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[0] - 1) % (2 * nfou)]
            [(allele_group[1] - 1) % (2 * nfou)][0] + .5;
      }
   }
   else if (allele2 == allele_group[1])
   {
      if (trt_data[temp->index] == 2)
      {
         Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][0] + 1;
      }
      else if (trt_data[temp->index] == 1)
      {
         Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][1] + 1;
      }
      else if (trt_data[temp->index] == 0)
      {
         Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][0] + .5;
         Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[1] - 1) % (2 * nfou)]
            [(allele_group[0] - 1) % (2 * nfou)][1] + .5;
      }
   }
   if (allele1 == allele_group[2])
   {
      if (trt_data[temp->index] == 2)
      {
         Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][0] + 1;
      }
      else if (trt_data[temp->index] == 1)
      {
         Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][1] + 1;
      }
      else if (trt_data[temp->index] == 0)
      {
         Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][1] + .5;
         Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[2] - 1) % (2 * nfou)]
            [(allele_group[3] - 1) % (2 * nfou)][0] + .5;
      }
   }
   else if (allele1 == allele_group[3])
   {
      if (trt_data[temp->index] == 2)
      {
         Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][0] + 1;
      }
      else if (trt_data[temp->index] == 1)
      {
         Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][1] + 1;
      }
      else if (trt_data[temp->index] == 0)
      {
         Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][1]
            = Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][1] + .5;
         Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][0]
            = Count_Matrix[(allele_group[3] - 1) % (2 * nfou)]
            [(allele_group[2] - 1) % (2 * nfou)][0] + .5;
      }
   }
   else
   {
      printf ("Default allele..mismatch at line(%d)\n", __LINE__);
   }
}

double CalPValue_lambdap (FILE * read_fp, int No_Permutation, int No_locus, int locus) /* p-value computation under (lambda,p) model */
{
   double obsval = -1000;
   int   p_cnt = 0;
   double p_val = 0;
   double val = 0;
   char  line[100];
   int   tag = 0;
   if (read_fp == NULL)
   {
      printf ("NULL File Pointer passed in CalPValue (%d)\n", __LINE__);
      return 0;
   }
   else
   {
      p_cnt = 0;
      while (fgets (line, 1000, read_fp) != NULL)
      {
         tag = tag + 1;
         val = -999;

         if ((tag == (locus + 1)) && (locus == 0))
         {
            sscanf (line, "%lf\n", &val);
            obsval = val;

         }

         else if ((tag == (locus + 1)) && (locus > 0))
         {
            sscanf (line, "%lf\n", &val);
            obsval = val;

         }
         else if ((tag > No_locus) && ((locus + 1) != No_locus)
                  && ((tag % No_locus) == (locus + 1)))
         {
            sscanf (line, "%lf\n", &val);

         }
         else if ((tag > No_locus) && ((tag % No_locus) == 0)
                  && ((locus + 1) == No_locus))
         {
            sscanf (line, "%lf\n", &val);

         }
         if ((val >= obsval) && (val > -999))
         {
            p_cnt = p_cnt + 1;
         }
      }
      p_val = (double) p_cnt / No_Permutation;
      return p_val;
   }
}
