/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*
 *   Autozgy/Lodscore setup functions:
 *     setPed(), setSwitches()
 */

# include "nghds.h"

/**
 * Read and store pedigree data.
 */
void setPed (double **qdata)
{
   int   n;
   FILE *pedF;

   /* allocate structures for pedgree data:  int data[PedSize][NColData]
    *                                        Ind nghd[PedSize + 1]  */
   alloc_ped ();

   /* open for reading */
   if (!(pedF = open_ped ()))
      give_up (ERR_qit);

   /* read in pedigree and trait data:       data[][]  */
   input_ped (pedF, qdata);

   fclose (pedF);

   /* set up neighborhood and pedigree components data structures */
   nghds ();

   /* do an extra check on no. founders */
   if ((n = count_founders ()) != nFound)
      give_up_where (WHERE, ERN_cfd, nFound, n);

   /* set up lists of members in each component and also 
      information about each component */
   if ((n_compnts = components ()) != nCompnt)
      give_up_where (WHERE, ERN_ccp, nCompnt, n_compnts);

   return;
}

/**
 * set and print the switches for each component.
 */
int setSwitches (void)
{
   int   nsw;

   nsw = make_switches ();
   prnt_switches (nsw);

   return nsw;
}
